#include "ThermometerPro.h"

#include "cmd.h"
#include "uptime.h"
#include "thermometer.h"
#include "Config.h"
#include "spi.h"


// #define ENABLE_CONFIGURATION_INVALID_CMD 1


static CmdServer cmdServer(&Serial);
#ifdef ENABLE_CONFIGURATION_INVALID_CMD
  static ConfigInvalidateCmd configInvalidateCmd;
#endif
static Uptime uptime;
static Thermometer thermometer;


void setup() {
  Serial.begin(9600);


  Config::initialize();


  spiInit();

  cmdServer.begin();
#ifdef ENABLE_CONFIGURATION_INVALID_CMD
  configInvalidateCmd.registerYourself(&cmdServer);
#endif
  uptime.begin(&cmdServer);
  thermometer.begin(&cmdServer);
}


void loop() {
  cmdServer.exec();
  uptime.exec();
  thermometer.exec();
}
